
(function(exports){'use strict';var WapPushManager={init:wpm_init,close:wpm_close,displayWapPushMessage:wpm_displayWapPushMessage,onVisibilityChange:wpm_onVisibilityChange,onWapPushReceived:wpm_onWapPushReceived,clearNotifications:wpm_clearNotifications};var wapPushEnableKeySim1='wap.push.enabled.sim1';var wapPushEnableKeySim2='wap.push.enabled.sim2';var wapPushEnabledSim1;var wapPushEnabledSim2;var app;var closeTimeout;var pendingMessages;function wpm_getApp(){return new Promise(function(resolve,reject){var req=navigator.mozApps.getSelf();req.onsuccess=function wpm_gotApp(){resolve(this.result);};req.onerror=function wpm_getAppError(){reject(this.error);};});}
function wpm_getConfig(key){return new Promise(function(resolve,reject){var req=navigator.mozSettings.createLock().get(key);req.onsuccess=function wpm_settingsLockSuccess(){resolve(this.result[key]);};req.onerror=function wpm_settingsLockError(){reject(this.error);};});}
function wpm_init(){wapPushEnabledSim1=true;wapPushEnabledSim2=true;app=null;closeTimeout=null;pendingMessages=0;navigator.mozSettings.addObserver(wapPushEnableKeySim1,wpm_onSettingsChangeSim1);navigator.mozSettings.addObserver(wapPushEnableKeySim2,wpm_onSettingsChangeSim2);var promise=Promise.all([wpm_getApp(),wpm_getConfig(wapPushEnableKeySim1),wpm_getConfig(wapPushEnableKeySim2),Utils.init(),WhiteList.init()]);promise=promise.then(function(values){app=values[0];wapPushEnabledSim1=values[1];wapPushEnabledSim2=values[2];SiSlScreenHelper.init();CpScreenHelper.init();OtaApnScreenHelper.init();window.navigator.mozSetMessageHandler('notification',wpm_onNotification);window.navigator.mozSetMessageHandler('wappush-received',wpm_onWapPushReceived);}).catch(function(error){wapPushEnabledSim1=false;wapPushEnabledSim2=false;error=error||'Unknown error';console.error('Could not initialize: ',error);return error;});return promise;}
function wpm_onSettingsChangeSim1(v){wapPushEnabledSim1=v.settingValue;}
function wpm_onSettingsChangeSim2(v){wapPushEnabledSim2=v.settingValue;}
function wpm_onVisibilityChange(){if(document.hidden){wpm_close();}else{window.clearTimeout(closeTimeout);closeTimeout=null;}}
function wpm_shouldDisplayMessage(message){if((message&&(((message.serviceId===0)&&!wapPushEnabledSim1)||((message.serviceId===1)&&!wapPushEnabledSim2)))||(message===null)){return false;}
if((message.type!=='text/vnd.wap.connectivity-xml')&&(!WhiteList.has(message.sender)||message.isExpired()||(message.type==='text/vnd.wap.si'&&message.action==='signal-none'))){return false;}
return true;}
function wpm_ignoreMessage(wapMessage){var dtag_mccmnc=['23101','23102','26201','23001','26002','21630','21901'];var mcc,mnc;if(wapMessage&&(wapMessage.serviceId===0||wapMessage.serviceId===1)){var connections=window.navigator.mozMobileConnections||[navigator.mozMobileConnection];if(connections.length>wapMessage.serviceId){var conn=connections[wapMessage.serviceId];if(conn&&conn.voice&&conn.voice.network&&conn.voice.connected){mcc=conn.voice.network.mcc;mnc=conn.voice.network.mnc;}}}
if(mcc&&mnc&&dtag_mccmnc.indexOf(''+mcc+mnc)>=0){if(wapMessage&&wapMessage.authInfo&&wapMessage.authInfo.sec&&wapMessage.authInfo.sec.toLowerCase()=="userpin"){return true;}}
return false;}
function wpm_sendNotification(message){var iconURL=null;var _=navigator.mozL10n.get;if(Utils.isDualSimDevice()&&Utils.hasSeveralSim()){iconURL='messages-sim'+(message.serviceId+1);}else{iconURL='messages';}
var text='';if(message.text){text=(message.type=='text/vnd.wap.connectivity-xml')?_(message.text):message.text;}
if(message.href){text+=(text?' ':'');text+=message.href;}
Utils.prepareMessageTitle(message).then((title)=>{let options={icon:iconURL,body:text,data:message,tag:message.timestamp};if(message.action&&message.action==='signal-low'){options.mozbehavior={silent:true,soundFile:'silent',vibrationPattern:[1]};}
let notification=new Notification(title,options);notification.addEventListener('click',function wpm_onNotificationClick(event){wpm_displayWapPushMessage(event.target.tag);});})}
function wpm_onWapPushReceived(wapMessage){DUMP('Received a message: ',wapMessage);if(wpm_ignoreMessage(wapMessage)){DUMP('The message will be ignored');wpm_finish();return Promise.resolve();}
pendingMessages++;var message=ParsedMessage.from(wapMessage,Date.now());DUMP("wap message"+"action"+message.action+"type=="+message.type+"sender=="+message.sender);if(!wpm_shouldDisplayMessage(message)){DUMP('The message will not be displayed');wpm_finish();return Promise.resolve();}
var handleReceivedWappushMsg=function(message){if(message.action==='signal-high'||message.action==='execute-high')
{pendingMessages--;Notify.ringtone();Notify.vibrate();return wpm_displayWapPushMessage(message.timestamp);}else{if(message.action!=='signal-none'){wpm_sendNotification(message);}
wpm_finish();return Promise.resolve();}};return message.save().then(function wpm_saveResolved(status){if(status==='discarded'){DUMP('The message was discarded');if(message.action==='delete'){wpm_clearNotifications('id',message.id);}
wpm_finish();return Promise.resolve();}
if(status==='updated'){wpm_clearNotifications('id',message.id).then(()=>{handleReceivedWappushMsg(message);});}else{handleReceivedWappushMsg(message);}
DUMP('The message was successfully saved to the DB');}).catch(function wpm_saveRejected(error){console.log('Could not add a message to the database: '+error+'\n');wpm_finish();return error;});}
function wpm_onNotification(message){if(!message.clicked){return;}
wpm_displayWapPushMessage(message.tag);}
function wpm_displayWapPushMessage(timestamp){DUMP('Displaying message '+timestamp);app.launch();window.clearTimeout(closeTimeout);closeTimeout=null;return ParsedMessage.load(timestamp).then(function wpm_loadResolved(message){if(message){switch(message.type){case'text/vnd.wap.si':case'text/vnd.wap.sl':SiSlScreenHelper.populateScreen(message);return wpm_clearNotifications('timestamp',timestamp);case'text/vnd.wap.connectivity-xml':OtaApnScreenHelper.showConfirmApplyDialog(message);break;}}else{SiSlScreenHelper.populateScreen();return wpm_clearNotifications('timestamp',timestamp);}}).catch(function(error){console.error('Could not retrieve the message: '+error.name+'\n');return error;});}
function wpm_clearNotifications(tag,value){return Notification.get().then(function onSuccess(notifications){for(var i=0;i<notifications.length;i++){if((notifications[i].data)[tag]===value){notifications[i].close();}}},function onError(error){console.error('Notification.get() promise error: '+error.name);return error;});}
function wpm_finish(){pendingMessages--;if(document.hidden){wpm_close();}}
function wpm_close(){if(closeTimeout!==null){return;}
closeTimeout=window.setTimeout(function wpm_delayedClose(){if(pendingMessages>0){closeTimeout=window.setTimeout(wpm_delayedClose,100);return;}
DUMP('Automatically closing the application');closeTimeout=null;window.close();},100);}
exports.WapPushManager=WapPushManager;})(this);